
#ifndef ATMO_ABILITY_HANDLER_H
#define ATMO_ABILITY_HANDLER_H

#include "atmosphere_platform.h"
#include "atmosphere_callbacks.h"

#include "../atmo/core.h"

#ifdef __cplusplus
	extern "C"{
#endif

#define ATMO_ABILITY(ELEMENT, NAME) ATMO_ ## ELEMENT ## _ABILITY_  ## NAME

void ATMO_AbilityHandler(unsigned int abilityHandleId, ATMO_Value_t *value);

#define ATMO_BLECharacteristicCustom_ABILITY_trigger 0x1
#define ATMO_BLECharacteristicCustom_ABILITY_setup 0x2
#define ATMO_BLECharacteristicCustom_ABILITY_setValue 0x3
#define ATMO_BLECharacteristicCustom_ABILITY_written 0x4
#define ATMO_BLECharacteristicCustom_ABILITY_subscibed 0x5
#define ATMO_BLECharacteristicCustom_ABILITY_unsubscribed 0x6
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_trigger 0x7
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setup 0x8
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setColorPreset 0x9
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setBrightnessLow 0xa
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setBrightnessOff 0xb
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setBrightnessMedium 0xc
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setBrightnessHigh 0xd
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setRedOn 0xe
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setGreenOn 0xf
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setBlueOn 0x10
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setWhiteOn 0x11
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_toggleRed 0x12
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_toggleGreen 0x13
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_toggleBlue 0x14
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setOff 0x15
#define ATMO_EmbeddedNxpRpkRgbLed_ABILITY_setColorHex 0x16
#define ATMO_GPIOPin_ABILITY_trigger 0x17
#define ATMO_GPIOPin_ABILITY_setup 0x18
#define ATMO_GPIOPin_ABILITY_setState 0x19
#define ATMO_GPIOPin_ABILITY_setPinHigh 0x1a
#define ATMO_GPIOPin_ABILITY_setPinLow 0x1b
#define ATMO_GPIOPin_ABILITY_read 0x1c
#define ATMO_GPIOPin_ABILITY_toggle 0x1d
#define ATMO_GPIOPin_ABILITY_interrupt 0x1e
#ifdef __cplusplus
}
#endif
#endif
