
#ifndef ATMO_CALLBACKS_H
#define ATMO_CALLBACKS_H

#include "atmosphere_platform.h"
#include "atmosphere_properties.h"
#include "atmosphere_variables.h"
#include "atmosphere_triggerHandler.h"
#include "atmosphere_interruptsHandler.h"
#include "atmosphere_embedded_libraries.h"
#include "atmosphere_abilityHandler.h"

#include "atmosphere_driverinstance.h"

#define ATMO_CALLBACK(ELEMENT, NAME) ELEMENT ## _ ## NAME

void ATMO_Setup();

ATMO_Status_t BLECharacteristicCustom_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLECharacteristicCustom_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLECharacteristicCustom_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLECharacteristicCustom_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLECharacteristicCustom_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLECharacteristicCustom_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setColorPreset(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setBrightnessLow(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setBrightnessOff(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setBrightnessMedium(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setBrightnessHigh(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setRedOn(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setGreenOn(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setBlueOn(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setWhiteOn(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_toggleRed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_toggleGreen(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_toggleBlue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setOff(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t EmbeddedNxpRpkRgbLed_setColorHex(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GPIOPin_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GPIOPin_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GPIOPin_setState(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GPIOPin_setPinHigh(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GPIOPin_setPinLow(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GPIOPin_read(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GPIOPin_toggle(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t GPIOPin_interrupt(ATMO_Value_t *in, ATMO_Value_t *out);
#endif
